﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Entity.Infrastructure;
using System.Diagnostics;
using System.Data.Entity.Infrastructure;
using System.Data.Entity;

namespace CDays2012
{
    class Program
    {
        static void Main(string[] args)
        {
            //InsertConEnum();
            //ReadConEnum();
            //TVF();
            //SPMultiResult1();
            //SPMultiResult2();
            Performance();
        }

        private static void InsertConEnum()
        {
            using (var ctx = new NorthwindEntities())
            {
                ctx.Orders.Add(new Order
                {
                    CustomerID = "ALFKI",
                    OrderDate = DateTime.Now,
                    ShipAddress = "Via milano 1",
                    ShipCity = "roma",
                    ShipCountry = "Italy",
                    ShipName = "StefanoMostarda",
                    ShipPostalCode = "00181",
                    ShipRegion = "Europa",
                    ShipVia = ShipVia.POSTEITALIANE,
                    Order_Details = new List<Order_Detail>
                    {
                        new Order_Detail {
                            Discount = 0,
                            ProductID = 1,
                            Quantity = 10,
                            UnitPrice = 200
                        }
                    }
                });
                ctx.SaveChanges();
                Console.ReadLine();
            }
        }

        private static void ReadConEnum()
        {
            using (var ctx = new NorthwindEntities())
            {
                ctx.Orders.Where(o => o.ShipVia == ShipVia.UPS).ToList().ForEach(o => Console.WriteLine(o.OrderID));
            }
        }

        private static void TVF()
        {
            using (var ctx = new NorthwindEntities())
            {
                ctx.GetDetailsForOrder(10248).Where(d => d.Quantity > 10).ToList().ForEach(o => Console.WriteLine(o.Quantity));
            }
        }

        private static void SPMultiResult1()
        {
            using (var ctx = new NorthwindEntities())
            {
                var r1 = ctx.CustWithRecentOrders("ALFKI");
                foreach (var result in r1)
                {
                    Console.WriteLine(
                      "{0} ({1})",
                      result.ContactName,
                      result.CompanyName);
                }

                var r2 = r1.GetNextResult<CustWithRecentOrders_Result2>();
                foreach (var result in r2)
                {
                    Console.WriteLine(
                      "{0} was ordered on {1}, required on {2} and shipped on {3}",
                      result.OrderID,
                      result.OrderDate,
                      result.RequiredDate,
                      result.ShippedDate);
                }
            }
        }

        private static void SPMultiResult2()
        {
            using (var ctx  = new NorthwindEntities()){
                ctx.Configuration.LazyLoadingEnabled = false;
                var r1 = ctx.GetOrderWithDetails(10248);
                var order = r1.First();
                var r2 = r1.GetNextResult<Order_Detail>().ToList();
            }
        }

        private static void Performance()
        {
            using (var ctx = new NorthwindEntities())
            {
                var x = ctx.Customers.Where(c => c.Country == "Italy").Select(c => c.CompanyName).ToList();
            }

            Stopwatch sw = new Stopwatch();
            sw.Start();
            for (var i = 0; i < 100; i++)
            {
                using (var ctx = new NorthwindEntities())
                {
                    var x = ctx.Customers.Where(c => c.Country == "Italy").Select(c => c.CompanyName).ToList();
                }
            }
            sw.Stop();
            Console.WriteLine(sw.Elapsed.TotalMilliseconds);

            sw.Restart();
            for (var i = 0; i < 100; i++)
            {
                using (var ctx = new NorthwindEntities())
                {
                    ((IObjectContextAdapter)ctx).ObjectContext.ContextOptions.DefaultQueryPlanCachingSetting = false;
                    var x = ctx.Customers.Where(c => c.Country == "Italy").Select(c => c.CompanyName).ToList();
                }
            }
            sw.Stop();
            Console.WriteLine(sw.Elapsed.TotalMilliseconds);
        }
    }
}
